/*
* ASIX up_control.dll interface
* It is distributed as-is, without any warranties.
* http://www.asix.net/
*
* version 1.1, November 2020
* 
*/


#include "UP_control.h"

// ------------------------------------------

int Load_UP_control_dll(char* filename)
{

    int LoadOK = 1; 
    
    hUP_control_dll = LoadLibraryA(filename);
    if (hUP_control_dll != NULL) {
    
     UP_Prog = (int (__stdcall *)(int, int, int, int, int))GetProcAddress(hUP_control_dll, "UP_Prog");
     UP_DiffProg = (int (__stdcall *)(int, int, int, int, int))GetProcAddress(hUP_control_dll, "UP_DiffProg");
     UP_Erase = (int (__stdcall *)(int, int, int, int))GetProcAddress(hUP_control_dll, "UP_Erase");
     UP_BlankCheck = (int (__stdcall *)(int, int, int, int, int))GetProcAddress(hUP_control_dll, "UP_BlankCheck");
     UP_Verify = (int (__stdcall *)(int, int, int, int, int))GetProcAddress(hUP_control_dll, "UP_Verify");
     UP_Read = (int (__stdcall *)(int, int, int, int, int))GetProcAddress(hUP_control_dll, "UP_Read"); 

     UP_ProgState = (int (__stdcall *)(int, int *))GetProcAddress(hUP_control_dll, "UP_ProgState");
     UP_LastErrorCode = (int (__stdcall *)(int))GetProcAddress(hUP_control_dll, "UP_LastErrorCode");       
     UP_ProgConfig	=	(int (__stdcall *)(int, char*, int, int, char*, char*))GetProcAddress(hUP_control_dll, "UP_ProgConfig");           
     UP_SetManualSN = (int (__stdcall *)(int, int, int))GetProcAddress(hUP_control_dll, "UP_SetManualSN");               
     UP_GetProgList = (int (__stdcall *)(int, int*, int, int*))GetProcAddress(hUP_control_dll, "UP_GetProgList");           
              
    
     if (!UP_Prog) LoadOK = 0;
     if (!UP_DiffProg) LoadOK = 0;
     if (!UP_Erase) LoadOK = 0;
     if (!UP_BlankCheck) LoadOK = 0;
     if (!UP_Verify) LoadOK = 0;
     if (!UP_Read) LoadOK = 0;
     
     if (!UP_ProgState) LoadOK = 0;
     if (!UP_LastErrorCode) LoadOK = 0;          
     if (!UP_ProgConfig) LoadOK = 0;
     if (!UP_SetManualSN) LoadOK = 0;
     if (!UP_GetProgList) LoadOK = 0;                             

     if (LoadOK == 0) { 
      FreeLibrary(hUP_control_dll); 
      return DLL_LOAD_ERROR; 
     } 
     else { 
      return DLL_LOAD_OK; 
     }
    }
    else {
     return DLL_LOAD_FILE_ERROR;
    }
}

